
/**
 * This a class to demonstrate the usage of the case statement in conjunction
 * with the break statement. It implements in its main() method the possiblity
 * to print a calenda. The main method asks the user to input two values:
 * "firstDay", an integer that codes the first week day of the month (1 =
 * monday and so an to 7 = sunday) and "maxDays" that contains the number of
 * the month's days.
 *
 * The task of the students is to find an error in the program code.
 * 
 * 
 * @author Thomas H. A. Dammann, Bernd J. Krmer
 * @version $Revision: 1.3 $ --- $Date: 2001/08/22 12:38:50 $
 */


public class PrintMonth
{

	public int maxDays,				// number of the month's days
			   firstDay,			// code of the first week day of the month
			   day,					// day
			   xDay,				// column of the calenda
			   yDay;				// row of the calenda

	/**
	 * Example of the lerning unit 3 to show the effect of break in conjunction
	 * with the case statement.
	 */

	public void main()
	{
		// Input the first week day and ensure that it lays in the interval [1,7]
		do{
			firstDay = Console.readInt("Please enter the first day of the month (1 = monday, ..., 7 = sunday): ");
		}while (firstDay < 1 && firstDay > 7);

		// Input the number of days and ensure that it lays in the interval [28,31]
		do{
			maxDays = Console.readInt("Please enter the number of month's days (28-31): ");
		}while (maxDays < 28 && maxDays > 31);

		// Loop through the row (= week days)
		for (yDay = 1; yDay <= 7; yDay++)
		{
			// print the abbreviation of the week day
			switch (yDay)
			{
				case 1: System.out.print("Mon"); break;
				case 2: System.out.print("Tue"); break;
				case 3: System.out.print("Wed"); break;
				case 4: System.out.print("Thu"); break;
				case 5: System.out.print("Fri"); break;
				case 6: System.out.print("Sat"); break;
				case 7: System.out.print("Sun"); break;
			}

			// Print the days in columns 1 to 5
			for (xDay = 1; xDay <= 5; xDay++)
			{
				// Evaluate the day with the formula given in the lerning unit
				day = 7 * xDay + yDay - (firstDay - 1) % 7;

				if (day >= 1 && day <= maxDays)
					// Here must the day be printed
					Format.print(System.out,"%3d",day);
				else
					// Else print an appropiate number of spaces
					System.out.print("	 ");
			}

			// The end of the line is reached, therefore print a newline character
			System.out.println();
		}
	}
}
